# -*- mode: ruby -*-
# vi: set ft=ruby :

ENV["LC_ALL"] = "en_US.UTF-8"
ENV['VAGRANT_DEFAULT_PROVIDER'] = 'virtualbox'


Vagrant.configure("2") do |config|

  # default settings for VBox
  config.vm.provider "virtualbox" do |vb|
    vb.gui    = false
    vb.memory = "1024"
  end

  # default box settings
  config.vm.box               = "centos/7"
  config.vm.box_check_update  = false

  # default shared folders:
  #   first, install host vagrant plugin:
  #     vagrant plugin install vagrant-vbguest
  #   3d argument is a set of options
  config.vm.synced_folder "host_data", "/host_data", SharedFoldersEnableSymlinksCreate: false

  # default provisioning
  config.vm.provision "shell", inline: <<-SHELL

    # common
    timedatectl set-timezone Europe/Moscow
    yum -y update
    yum -y install epel-release bash bash-completion curl wget elinks gitlll

    # VBox Guest Additions manual installation
    yum -y group install "Development Tools"
    yum -y install curl kernel-devel kernel-headers
    echo "downloading VBoxGuestAdditions..."
    curl -SsL https://download.virtualbox.org/virtualbox/6.0.14/VBoxGuestAdditions_6.0.14.iso > /tmp/VBoxGuestAdditions.iso
    mount -o ro,loop /tmp/VBoxGuestAdditions.iso /mnt
    sh /mnt/VBoxLinuxAdditions.run --check && sh /mnt/VBoxLinuxAdditions.run --nox11

SHELL

  # ansible
  config.vm.define "ctl" do |ctl|
    ctl.vm.provider "virtualbox" do |vb|
      #vb.memory = "4096"
    end
    ctl.vm.network "private_network", ip: "172.16.1.100"
  end

  # prometheus
  config.vm.define "mon" do |mon|
    mon.vm.provider "virtualbox" do |vb|
      #vb.memory = "4096"
    end
    mon.vm.network "private_network", ip: "172.16.1.101"
    mon.vm.network "forwarded_port", guest: 9090, host: 9090, host_ip: "127.0.0.1"

  end

  # # mgmt
  # config.vm.define "mgmt" do |mgmt|
  #   mgmt.vm.network "private_network", ip: "172.16.1.25"
  #   # mgmt.vm.network "forwarded_port", guest: 80, host: 8080
  #   # mgmt.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"
  #   # mgmt.vm.network "public_network"
  #   mgmt.vm.provider "virtualbox" do |vb|
  #     vb.memory = "1024"
  #     vb.customize ["modifyvm", :id, "--nic1", "nat"]
  #     vb.customize ["modifyvm", :id, "--nic2", "natnetwork" ]
  #   end
  # end
  #
  # # cpu1-2
  # for i in 1..1 do
  #   config.vm.define "cpu#{i}" do |cpu|
  #     cpu.vm.network "private_network", ip: "172.16.1.#{i}"
  #     cpu.vm.provider "virtualbox" do |vb|
  #       vb.memory = "4096"
  #     end
  #   end
  # end

end
